-- Integer1.lua: Integer functions 1
-- 2021-Feb-10 14.28 / TNA

local type = type
local tostring = tostring
local math = math
local error = error

_ENV = nil

local Integer1 = {}

Integer1.progName = "Integer1"
Integer1.progStamp = "2021-May-07 11.19"

function Integer1.ensureInteger( x )

  if  type( x ) ~= type( 7 ) or math.type( x ) ~= math.type( 7 ) then
    error( Integer1.progName .. ": type/math.type( x=" .. tostring( x ) .. " ) = <" .. type( x ) .. "/" .. tostring( math.type( x ) ) .. ">: Expected <" .. type( 7 ) .. "/" .. math.type( 7 ) .. ">" )
  end

end

function Integer1.gcd( x, y )

  Integer1.ensureInteger( x )
  Integer1.ensureInteger( y )

  while y ~= 0 do
    local t = math.abs( y )
    y = math.abs( x ) % y
    x = t
  end

  return x

end

return Integer1
